-- Job Costing Plugin

function OnShowOptions(event)
    event:GetTextCtrl():AppendText("SheetCam Master Tool Table Plugin \n")
end

evtHdlr = wx.wxEvtHandler()

function OnStart()
PATH2 =sc.GetMyPath().."\\MasterToolSet.tls"
evtHdlr = wx.wxEvtHandler()



UI = {} --A convenient way to store all of the information the window/dialog creates.


-- create ToolTableDialog
UI.m_MaterialCostDialog = wx.wxDialog (wx.NULL, wx.wxID_ANY, "Master Tool Set", wx.wxDefaultPosition, wx.wxDefaultSize, wx.wxDEFAULT_DIALOG_STYLE )--create and name the window with desired settings
	UI.m_MaterialCostDialog:SetSizeHints( wx.wxDefaultSize, wx.wxDefaultSize )
	
	UI.bSizer4 = wx.wxBoxSizer( wx.wxVERTICAL )--create a sizer to place elements in
	
	UI.m_MaterialCostGrid = wx.wxGrid( UI.m_MaterialCostDialog, wx.wxID_ANY, wx.wxDefaultPosition, wx.wxDefaultSize, 0 )
	 -------------------------GRID SETTINGS------------------------------------------
	-- Grid
	UI.m_MaterialCostGrid:CreateGrid( 100, 14 )
	UI.m_MaterialCostGrid:EnableDragGridSize( False )
	UI.m_MaterialCostGrid:SetMargins( 0, 0 )
	
	-- Columns
	UI.m_MaterialCostGrid:SetColSize( 0, 50 )
	UI.m_MaterialCostGrid:SetColSize( 1, 50 )
	UI.m_MaterialCostGrid:SetColSize( 2, 150 )
	UI.m_MaterialCostGrid:SetColSize( 3, 70 )
	UI.m_MaterialCostGrid:SetColSize( 4, 70 )
	UI.m_MaterialCostGrid:SetColSize( 5, 70 )
	UI.m_MaterialCostGrid:SetColSize( 6, 70 )
	UI.m_MaterialCostGrid:SetColSize( 7, 70 )
   UI.m_MaterialCostGrid:SetColSize( 8, 70 )
	UI.m_MaterialCostGrid:SetColSize( 9, 70 )
	UI.m_MaterialCostGrid:SetColSize( 10, 70 )
	UI.m_MaterialCostGrid:SetColSize( 11, 70 )
   UI.m_MaterialCostGrid:SetColSize( 12, 70 )
	UI.m_MaterialCostGrid:SetColSize( 13, 150 )
	
   
	UI.m_MaterialCostGrid:EnableDragColSize( True )
	UI.m_MaterialCostGrid:SetColLabelSize( 50 )
	UI.m_MaterialCostGrid:SetColLabelAlignment( wx.wxALIGN_CENTRE, wx.wxALIGN_CENTRE )
	
	-- Rows
	UI.m_MaterialCostGrid:AutoSizeRows()
	UI.m_MaterialCostGrid:EnableDragRowSize( True )
	UI.m_MaterialCostGrid:SetRowLabelSize( 80 )
	UI.m_MaterialCostGrid:SetRowLabelAlignment( wx.wxALIGN_CENTRE, wx.wxALIGN_CENTRE )
	
	-- Label Appearance
	
	-- Cell Defaults
	UI.m_MaterialCostGrid:SetDefaultCellAlignment( wx.wxALIGN_LEFT, wx.wxALIGN_TOP )
	UI.m_MaterialCostGrid:SetMinSize( wx.wxSize( 700,520 ) )
	UI.m_MaterialCostGrid:SetMaxSize( wx.wxSize( 700,520 ) )
	-------------------------END GRID SETTINGS------------------------------------------
	
	UI.bSizer4:Add( UI.m_MaterialCostGrid, 0, wx.wxALL + wx.wxALIGN_CENTER_HORIZONTAL, 5 )
	
	UI.m_sdbSizer2 = wx.wxStdDialogButtonSizer()
	UI.m_sdbSizer2OK = wx.wxButton( UI.m_MaterialCostDialog, wx.wxID_OK, "" )--Add an "OK" button to the bottom of the dialog.
	UI.m_sdbSizer2:AddButton( UI.m_sdbSizer2OK )
	UI.m_sdbSizer2:Realize();
	
	UI.bSizer4:Add( UI.m_sdbSizer2, 1, wx.wxALIGN_CENTER_HORIZONTAL, 5 )
		
	UI.m_MaterialCostDialog:SetSizer( UI.bSizer4 )
	UI.m_MaterialCostDialog:Layout()
	UI.bSizer4:Fit( UI.m_MaterialCostDialog )
	
	UI.m_MaterialCostDialog:Centre( wx.wxBOTH )
	
	-- Connect Events
   
  
   
 
	UI.m_MaterialCostGrid:Connect( wx.wxEVT_GRID_LABEL_RIGHT_CLICK, function(event)
	 row = event:GetRow()
    ToolGroup = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
        
cfg=wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE) 

    settings= wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
   settings:SetPath("Tool"..ToolGroup)
   a,Toolnumber = settings:Read("Tool\ number")
   a,Diameter = settings:Read("Diameter")
   a,Name = settings:Read("Name")
   a,FluteLen = settings:Read("Flute\ length")
   a,SpinRPM = settings:Read("Spindle\ speed")
   a,SpinDIR = settings:Read("Spindle\ direction")
   a,ToolLen = settings:Read("Tool\ length\ offset")
   a,Zinc = settings:Read("Depth\ per\ pass")
   a,PntAngle = settings:Read("Point\ angle")
   a,PlngRate = settings:Read("Plunge\ rate")
   a,FeedRate = settings:Read("Feed\ rate")
   a,RampAngle = settings:Read("Ramp\ Angle")
   a,Type = settings:Read("Type")
   a,Comment = settings:Read("Comment")
 
parts=sc.Parts.Get()
tools=parts.tools

tool = sc.MillTool() --create a new Mill Tool
tool.name:op_set(Name)
tool.number:op_set(tonumber(Toolnumber))
tool.diameter:op_set(tostring(Diameter)) 
tool.fluteLength:op_set(FluteLen)
tool.feedRate:op_set(FeedRate)
tool.plungeRate:op_set(PlngRate) 
--tool.RampAngle:op_set(RampAngle)
tool.spindleSpeed:op_set(SpinRPM)
tools:Add(tool)
--You also need this after creating tools. It updates the GUI.
parts:SetDirty(sc.DIRTY_TOOLS)
 
    event:Skip()
	end )
   -----------------------------------------------------------------------------
lastrow = 0
lastcol = 0
   
------------------EVENTS--------------------------------------------------------

	
 
 
   
-------------------------------   
   
   UI.m_MaterialCostGrid:Connect( wx.wxEVT_GRID_CELL_CHANGE, function(event) --This is an event handler that happens when the user changes data in a cell.
		row = event:GetRow()
       col = event:GetCol()
        event:Skip()
      
		toolnum = 1 --row+1; --since tooling starts at tool 1 and row starts at 0, we have to add 1 to the row to get the correct tool.
		
      if(col == 0) then --update the Material Name
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      Tool =(UI.m_MaterialCostGrid:GetCellValue(row, col))
      
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Tool\ number",Tool)
            settings:Flush()
      
      elseif(col == 1) then --update the Material Cost
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      Diameter =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            print("Tool"..TOOL)
            --to write a value
            settings:Write("Diameter",Diameter)
            print(""..Diameter)
            settings:Flush()
      
      elseif(col == 2) then --update the Material Type
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      Name =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Name",Name)
            settings:Flush()
      
      elseif(col == 3) then --update the Material Vendor
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      FluteLen =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Flute\ length",FluteLen)
            settings:Flush()
      
      elseif(col == 4) then --update the Material Cost
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      FeedRate =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Feed\ rate",FeedRate)
            settings:Flush()
      
      elseif(col == 5) then --update the Material Type
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      RampAngle =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Ramp\ angle",RampAngle)
            settings:Flush()
      
      elseif(col == 6) then --update the Material Vendor
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      Zinc =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Depth\ per\ pass",Zinc)
            settings:Flush()
      
      elseif(col == 7) then --update the Material Cost
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      SpinRPM =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Spindle\ speed",SpinRPM)
            settings:Flush()
      
      elseif(col == 8) then --update the Material Type
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      SpinDIR =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Spindle\ direction",SpinDIR)
            settings:Flush()
      
      elseif(col == 9) then --update the Material Vendor
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      ToolLen =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Tool\ length\ offset",ToolLen)
            settings:Flush()
      
      elseif(col == 10) then --update the Material Cost
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      PntAngle =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Point\ angle",PntAngle)
            settings:Flush()
      
      elseif(col == 11) then --update the Material Type
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      PlngRate =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Plunge\ rate",PlngRate)
            settings:Flush()
      
      elseif(col == 12) then --update the Material Vendor
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      Type =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Type",Type)
            settings:Flush()
      
      elseif(col == 13) then --update the Material Vendor
		TOOL = ((UI.m_MaterialCostGrid:GetCellValue(row, 0))-1)
      Comment =(UI.m_MaterialCostGrid:GetCellValue(row, col))
            settings = wx.wxFileConfig("","",PATH2,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("Tool"..TOOL)
            --to write a value
            settings:Write("Comment",Comment)
            settings:Flush()
		end
	end )
	
	function SetupToolTable()
        UI.m_MaterialCostGrid:SetColLabelValue(0, "Tool")--Set the labels for the columns
        UI.m_MaterialCostGrid:SetColLabelValue(1, "Diam")
        UI.m_MaterialCostGrid:SetColLabelValue(2, "Description")
        UI.m_MaterialCostGrid:SetColLabelValue(3, "Flute Len")
        UI.m_MaterialCostGrid:SetColLabelValue(4, "Feed Rate")--Set the labels for the columns
        UI.m_MaterialCostGrid:SetColLabelValue(5, "Ramp Angle")
        UI.m_MaterialCostGrid:SetColLabelValue(6, "Z Inc")
        UI.m_MaterialCostGrid:SetColLabelValue(7, "Spin RPM")
        UI.m_MaterialCostGrid:SetColLabelValue(8, "Spin DIR")
        UI.m_MaterialCostGrid:SetColLabelValue(9, "Tool Len")
        UI.m_MaterialCostGrid:SetColLabelValue(10, "Point Angle")
        UI.m_MaterialCostGrid:SetColLabelValue(11, "Plunge Rate")--Set the labels for the columns
        UI.m_MaterialCostGrid:SetColLabelValue(12, "Type")
        UI.m_MaterialCostGrid:SetColLabelValue(13, "Comment")
        
		
 I = 0
------------------------------Sort Table
PATH =sc.GetMyPath().."\\MasterToolSet.tls"
--PATH = "C:\\Program Files\\SheetCam TNG Development\\plugins\\Test_PI\\MasterToolSet.tls"
cfg=wx.wxFileConfig("","",PATH,"",wx.wxCONFIG_USE_LOCAL_FILE) 
found,name,index=cfg:GetFirstGroup()
  while found do
    settings= wx.wxFileConfig("","",PATH,"",wx.wxCONFIG_USE_LOCAL_FILE)
   settings:SetPath(""..name)
   a,Toolnumber = settings:Read("Tool\ number")
   a,Diameter = settings:Read("Diameter")
   a,Name = settings:Read("Name")
   a,FluteLen = settings:Read("Flute\ length")
   a,SpinRPM = settings:Read("Spindle\ speed")
   a,SpinDIR = settings:Read("Spindle\ direction")
   a,ToolLen = settings:Read("Tool\ length\ offset")
   a,Zinc = settings:Read("Depth\ per\ pass")
   a,PntAngle = settings:Read("Point\ angle")
   a,PlngRate = settings:Read("Plunge\ rate")
   a,FeedRate = settings:Read("Feed\ rate")
   a,RampAngle = settings:Read("Ramp\ Angle")
   a,Type = settings:Read("Type")
   a,Comment = settings:Read("Comment")
   
   

   returndouble = Toolnumber 
 UI.m_MaterialCostGrid:SetCellValue(I,0, tostring(returndouble))
 
 returndouble = Diameter 
 UI.m_MaterialCostGrid:SetCellValue(I,1, tostring(returndouble))
 
returndouble = Name 
 UI.m_MaterialCostGrid:SetCellValue(I,2, tostring(returndouble))
 
 returndouble = FluteLen 
 UI.m_MaterialCostGrid:SetCellValue(I,3, tostring(returndouble))
 
   returndouble = FeedRate 
 UI.m_MaterialCostGrid:SetCellValue(I,4, tostring(returndouble))
 
 returndouble = RampAngle 
 UI.m_MaterialCostGrid:SetCellValue(I,5, tostring(returndouble))
 
returndouble = Zinc 
 UI.m_MaterialCostGrid:SetCellValue(I,6, tostring(returndouble))
 
 returndouble = SpinRPM 
 UI.m_MaterialCostGrid:SetCellValue(I,7, tostring(returndouble))
 
   returndouble = SpinDIR
 UI.m_MaterialCostGrid:SetCellValue(I,8, tostring(returndouble))
 
 returndouble = ToolLen
 UI.m_MaterialCostGrid:SetCellValue(I,9, tostring(returndouble))
 
returndouble = PntAngle 
 UI.m_MaterialCostGrid:SetCellValue(I,10, tostring(returndouble))
 
 returndouble = PlngRate 
 UI.m_MaterialCostGrid:SetCellValue(I,11, tostring(returndouble))
 
   returndouble = Type 
 UI.m_MaterialCostGrid:SetCellValue(I,12, tostring(returndouble))
 
 returndouble = Comment 
 UI.m_MaterialCostGrid:SetCellValue(I,13, tostring(returndouble))
 

       
   I = (I+1)
       
  found,name,index=cfg:GetNextGroup(index)
end

    end

    SetupToolTable()
    UI.m_MaterialCostDialog:Show()




end





---------------------------------------------------------------------------
function main()
    --add a menu to the main application
    local app = sc.scApp();
    local bitmapPath = sc.GetMyPath()

    local a = _("SCJobCost") --a bit of fudgery here, these are just here for gettext.
    a = _("&ScJobCost") --gettext will add these to the catalog. TNG then reads the catalog on calls to AddMenu and SetMenuPath
 
    app:SetMenuPath("/&Plugins")
    
    ID_START = app:AddMenu(evtHdlr,"Plugins","MasterToolSet",_("MasterToolSet"),bitmapPath.."",sc.ITEM_NORMAL)
    app:UpdateBars() --regenerate toolbars
    evtHdlr:Connect(ID_START, sc.wxEVT_ACTION, OnStart)
end

main()


